import { login, logout, getInfo } from '@/api/login'
import { getToken, setToken, removeToken } from '@/utils/auth'
import Cookies from 'js-cookie'

const user = {
  state: {
    token: getToken(),
    id: '',
    name: '',
    avatar: '',
    roles: [],
    permissions: [],
    nickName: '',
    deptId: '',
    deptName: '',
    orgId: '',
    orgName: '',
    adminDept: '',
    adminDeptName: ''
  },

  mutations: {
    SET_TOKEN: (state, token) => {
      state.token = token
    },
    SET_ID: (state, id) => {
      state.id = id
    },
    SET_NAME: (state, name) => {
      state.name = name
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions
    },
    NICKNAME: (state, nickName) => {
      state.nickName = nickName
    },
    DEPTID: (state, deptId) => {
      state.deptId = deptId
    },
    DEPTNAME: (state, deptName) => {
      state.deptName = deptName
    },
    ORGID: (state, orgId) => {
      state.orgId = orgId
    },
    ORGNAME: (state, orgName) => {
      state.orgName = orgName
    },
    ADMINDEPT: (state, adminDept) => {
      state.adminDept = adminDept
    },
    ADMINDEPTNAME: (state, adminDeptName) => {
      state.adminDeptName = adminDeptName
    },
  },

  actions: {
    // 登录
    Login({ commit }, userInfo) {
      const username = userInfo.username.trim()
      const password = userInfo.password
      const code = userInfo.code
      const uuid = userInfo.uuid
      return new Promise((resolve, reject) => {
        login(username, password, code, uuid).then(res => {
          setToken(res.token)
          commit('SET_TOKEN', res.token)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 获取用户信息
    GetInfo({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo().then(res => {
          console.log("res",res);
          const user = res.user
          console.log("user",user);
          const avatar = (user.avatar == "" || user.avatar == null) ? require("@/assets/images/profile.jpg") : process.env.VUE_APP_BASE_API + user.avatar;
          if (res.roles && res.roles.length > 0) { // 验证返回的roles是否是一个非空数组
            commit('SET_ROLES', res.roles)
            Cookies.set('roles',res.roles,{ expires: 30 });
            commit('SET_PERMISSIONS', res.permissions)
          } else {
            commit('SET_ROLES', ['ROLE_DEFAULT'])
          }
          commit('SET_NAME', user.userName)
          commit('SET_ID', user.userId)
          commit('SET_AVATAR', avatar)
          commit('NICKNAME', user.nickName)
          commit('DEPTID', user.deptId)
          commit('DEPTNAME', user.deptName)
          commit('ORGID', user.orgId)
          commit('ORGNAME', user.orgName)
          commit('ADMINDEPT', user.adminDept)
          commit('ADMINDEPTNAME', user.adminDeptName)
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 退出系统
    LogOut({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token).then(() => {
          commit('SET_TOKEN', '')
          commit('SET_ROLES', [])
          commit('SET_PERMISSIONS', [])
          removeToken()
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 前端 登出
    FedLogOut({ commit }) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '')
        removeToken()
        resolve()
      })
    }
  }
}

export default user
